-- By D4KiR

if DUFBUILD == "CLASSIC" then
	RAID_CLASS_COLORS["DRUID"] = {
		["r"] = 255 / 255,
		["g"] = 125 / 255,
		["b"] = 10 / 255,
		["colorStr"] = "FF7D0A"
	}
	RAID_CLASS_COLORS["HUNTER"] = {
		["r"] = 171 / 255,
		["g"] = 212 / 255,
		["b"] = 115 / 255,
		["colorStr"] = "ABD473"
	}
	RAID_CLASS_COLORS["MAGE"] = {
		["r"] = 105 / 255,
		["g"] = 204 / 255,
		["b"] = 240 / 255,
		["colorStr"] = "69CCF0"
	}
	RAID_CLASS_COLORS["PALADIN"] = {
		["r"] = 245 / 255,
		["g"] = 140 / 255,
		["b"] = 186 / 255,
		["colorStr"] = "F58CBA"
	}
	RAID_CLASS_COLORS["PRIEST"] = {
		["r"] = 255 / 255,
		["g"] = 255 / 255,
		["b"] = 255 / 255,
		["colorStr"] = "FFFFFF"
	}
	RAID_CLASS_COLORS["ROGUE"] = {
		["r"] = 255 / 255,
		["g"] = 245 / 255,
		["b"] = 105 / 255,
		["colorStr"] = "FFF569"
	}
	RAID_CLASS_COLORS["SHAMAN"] = {
		["r"] = 0 / 255,
		["g"] = 112 / 255,
		["b"] = 222 / 255,
		["colorStr"] = "0070DE"
	}
	RAID_CLASS_COLORS["WARLOCK"] = {
		["r"] = 148 / 255,
		["g"] = 130 / 255,
		["b"] = 201 / 255,
		["colorStr"] = "9482C9"
	}
	RAID_CLASS_COLORS["WARRIOR"] = {
		["r"] = 199 / 255,
		["g"] = 156 / 255,
		["b"] = 110 / 255,
		["colorStr"] = "C79C6E"
	}
end

function DUFNN(value, short)
	value = tonumber(value) or value
	if value > 999999999 then
		if short then
			return format("%.0f B", value / 1000000000)
		end
		return format("%.1f B", value / 1000000000)
	elseif value > 999999 then
		if short then
			return format("%.0f M", value / 1000000)
		end
		return format("%.1f M", value / 1000000)
	elseif value > 999 then
		if short then
			return format("%.0f K", value / 1000)
		end
		return format("%.1f K", value / 1000)
	else
		return value
	end
end



function DUFUpdateText()
	local php = DUFNN(UnitHealth("PLAYER"))
	PlayerFrameHealthBarTextRight:SetText(php)
	local ppo = DUFNN(UnitPower("PLAYER"))
	PlayerFrameManaBarTextRight:SetText(ppo)
	
	if TargetFrameHealthBarTextRight then
		local thp = DUFNN(UnitHealth("TARGET"))
		TargetFrameHealthBarTextRight:SetText(thp)
	end
	if TargetFrameManaBarTextRight then
		local tpo = DUFNN(UnitPower("TARGET"))
		TargetFrameManaBarTextRight:SetText(tpo)
	end
end



hooksecurefunc("UnitFramePortrait_Update", function(self)
	if self.portrait then
		local class, classEng, classID = UnitClass(self.unit)
		local t = CLASS_ICON_TCOORDS[select(2, UnitClass(self.unit))]
		if t and UnitIsPlayer(self.unit) then
			if DUFGetConfig("portraimode") == "New" then
				self.portrait:SetTexture("Interface\\Addons\\D4KiR DUnitFrames\\media\\UI-CLASSES-CIRCLES-NEW")
				self.portrait:SetTexCoord(unpack(t))
			elseif DUFGetConfig("portraimode") == "Old" then
				self.portrait:SetTexture("Interface\\Addons\\D4KiR DUnitFrames\\media\\UI-CLASSES-CIRCLES-OLD")
				self.portrait:SetTexCoord(unpack(t))
			else
				self.portrait:SetTexCoord(0, 1, 0, 1)
			end
		else
			self.portrait:SetTexCoord(0, 1, 0, 1)
		end
	end
end)



-- #PlayerFrame
function DUFUpdatePlayerFrame()
	local texture = "Interface\\Addons\\D4KiR DUnitFrames\\media\\UI-TargetingFrame"
	PlayerFrameTexture:SetTexture(texture)
	PlayerStatusTexture:SetTexture("Interface\\Addons\\D4KiR DUnitFrames\\media\\UI-Player-Status")

	local height = DUFGetConfig("hpheight", 27)
	PlayerFrameHealthBar:SetHeight(height)
	PlayerFrameHealthBar:SetPoint("TOPLEFT", 106, -24)
	PlayerFrameManaBar:SetHeight(40 - height)
	PlayerFrameManaBar:SetPoint("TOPLEFT", 106, -24 -height - 1)

	PlayerFrameHealthBarTextLeft:SetPoint("LEFT", PlayerFrameHealthBar, "LEFT", 2, 0.5)
	PlayerFrameHealthBarTextRight:SetPoint("RIGHT", PlayerFrameHealthBar, "RIGHT", 0, 0.5)
	PlayerFrameHealthBarText:SetPoint("CENTER", PlayerFrameHealthBar, "CENTER", 0, 0)

	PlayerFrameManaBarTextLeft:SetPoint("LEFT", PlayerFrameManaBar, "LEFT", 2, 1)
	PlayerFrameManaBarTextRight:SetPoint("RIGHT", PlayerFrameManaBar, "RIGHT", 0, 1)
	PlayerFrameManaBarText:SetPoint("CENTER", PlayerFrameManaBar, "CENTER", 0, 0)

	local height = DUFGetConfig("hpheight", 27)
	if PlayerFrameTexture.spacer == nil then
		PlayerFrameTexture.spacer = PlayerFrameTexture:GetParent():CreateTexture(nil, "ARTWORK")
		PlayerFrameTexture.spacer:SetDrawLayer("ARTWORK", 7)

		hooksecurefunc(PlayerFrameTexture.spacer, "SetVertexColor", function(self, r, g, b, a)
			if self.setvertexcolor then return end
			self.setvertexcolor = true
			self:SetVertexColor(r, g, b, a)
			self.setvertexcolor = false
		end)
		PlayerFrameTexture.spacer:SetVertexColor(1, 1, 1, 1)
	end
	PlayerFrameTexture.spacer:SetTexCoord(0, 1, 1, 0);
	PlayerFrameTexture.spacer:SetSize(128, 16)
	PlayerFrameTexture.spacer:SetPoint("RIGHT", PlayerFrameTexture, "RIGHT", 1, 30 - height)
	PlayerFrameTexture.spacer:SetTexture(texture .. "_Spacer")

	PlayerFrameTexture:SetVertexColor(1, 1, 1, 1)
end

hooksecurefunc(PlayerFrameHealthBar, "SetStatusBarColor", function(self, ...)
	if self.setvertexcolor then return end
	self.setvertexcolor = true
	local PlayerClass, PlayerClassEng, PlayerClassIndex = UnitClass("PLAYER")
	if PlayerClass ~= nil then
		local rPerc, gPerc, bPerc, argbHex = GetClassColor(PlayerClassEng)
		self:SetStatusBarColor(rPerc, gPerc, bPerc)
	end
	self.setvertexcolor = false
end)
PlayerFrameHealthBar:SetStatusBarColor(1, 1, 1, 1)

hooksecurefunc(PlayerFrameHealthBarTextLeft, "SetText", function(self, ...)
	local fontFamily, fontSize, fontFlags = self:GetFont()
	self:SetFont(fontFamily, 10, fontFlags)
end)
PlayerFrameHealthBarTextLeft:SetText(PlayerFrameHealthBarTextLeft:GetText())

hooksecurefunc(PlayerFrameHealthBarTextRight, "SetText", function(self, ...)
	local fontFamily, fontSize, fontFlags = self:GetFont()
	self:SetFont(fontFamily, 10, fontFlags)
end)
PlayerFrameHealthBarTextRight:SetText(PlayerFrameHealthBarTextRight:GetText())

hooksecurefunc(PlayerFrameHealthBarText, "SetText", function(self, ...)
	local fontFamily, fontSize, fontFlags = self:GetFont()
	self:SetFont(fontFamily, 10, fontFlags)
end)
PlayerFrameHealthBarText:SetText(PlayerFrameHealthBarText:GetText())

hooksecurefunc(PlayerFrameManaBarTextLeft, "SetText", function(self, ...)
	local fontFamily, fontSize, fontFlags = self:GetFont()
	self:SetFont(fontFamily, 10, fontFlags)
end)
PlayerFrameManaBarTextLeft:SetText(PlayerFrameManaBarTextLeft:GetText())

hooksecurefunc(PlayerFrameManaBarTextRight, "SetText", function(self, ...)
	local fontFamily, fontSize, fontFlags = self:GetFont()
	self:SetFont(fontFamily, 10, fontFlags)
end)
PlayerFrameManaBarTextRight:SetText(PlayerFrameManaBarTextRight:GetText())

hooksecurefunc(PlayerFrameManaBarText, "SetText", function(self, ...)
	local fontFamily, fontSize, fontFlags = self:GetFont()
	self:SetFont(fontFamily, 10, fontFlags)
end)
PlayerFrameManaBarText:SetText(PlayerFrameManaBarText:GetText())

hooksecurefunc(PlayerName, "SetText", function(self, text, ...)
	local fontFamily, fontSize, fontFlags = self:GetFont()
	self:SetFont(fontFamily, 8, fontFlags)
	self:SetPoint("BOTTOM", PlayerFrameHealthBar, "TOP", 0, 3)
end)
PlayerName:SetText(PlayerName:GetText())

function GetBorderColor(unit)
	local r = 1
	local g = 1
	local b = 1
	local mode = DUFGetConfig("bordermode")
	local PlayerClass, PlayerClassEng, PlayerClassIndex = UnitClass(unit)
	if mode then
		if mode == "Class+Status" then
			if PlayerClass ~= nil and UnitIsPlayer(unit) then
				r, g, b = GetClassColor(PlayerClassEng)
			else
				r, g, b = GameTooltip_UnitColor(unit);
			end
		elseif DUFGetConfig("bordermode", "Class") == "Class" then
			if PlayerClass ~= nil and UnitIsPlayer(unit) then
				r, g, b = GetClassColor(PlayerClassEng)
			end
		elseif mode == "Status" then
			r, g, b = GameTooltip_UnitColor(unit);
		elseif mode == "Dark" then
			r = 0.1
			g = 0.1
			b = 0.1
		elseif mode == "Black" then
			r = 0
			g = 0
			b = 0
		else
			r = 1
			g = 1
			b = 1
		end
	end
	return r, g, b
end

hooksecurefunc(PlayerFrameTexture, "SetVertexColor", function(self, ...)
	if self.setvertexcolor then return end
	self.setvertexcolor = true
	local r, g, b = GetBorderColor("PLAYER")
	self:SetVertexColor(r, g, b, 1)
	if self.spacer then
		self.spacer:SetVertexColor(r, g, b, 1)
	end
	self.setvertexcolor = false
end)
PlayerFrameTexture:SetVertexColor(1, 1, 1, 1)



-- #TargetFrame
function DUFUpdateTargetFrame()
	local height = DUFGetConfig("hpheight", 27)
	TargetFrameHealthBar:SetHeight(height)
	TargetFrameHealthBar:SetPoint("TOPLEFT", 7, -23)
	TargetFrameManaBar:SetHeight(40 - height)
	TargetFrameManaBar:SetPoint("TOPLEFT", 7, -23 -height - 1)

	TargetFrameNameBackground:Hide()
	TargetFrameBackground:SetHeight(40)

	if TargetFrameHealthBar.hooked == nil then
		TargetFrameHealthBar.hooked = true

		hooksecurefunc(TargetFrameHealthBar, "SetStatusBarColor", function(self, ...)
			if self.setvertexcolor then return end
			self.setvertexcolor = true
			local PlayerClass, PlayerClassEng, PlayerClassIndex = UnitClass("TARGET")
			if PlayerClass ~= nil and UnitIsPlayer("TARGET") then
				local rPerc, gPerc, bPerc, argbHex = GetClassColor(PlayerClassEng)
				self:SetStatusBarColor(rPerc, gPerc, bPerc)
			else
				local r, g, b = GameTooltip_UnitColor("TARGET");
				self:SetStatusBarColor(r, g, b, 1)
			end
			self.setvertexcolor = false
		end)
		TargetFrameHealthBar:SetStatusBarColor(1, 1, 1, 1)
	end

	if TargetFrameHealthBarTextLeft ~= nil then
		if TargetFrameHealthBarTextLeft.hooked == nil then
			TargetFrameHealthBarTextLeft.hooked = true

			hooksecurefunc(TargetFrameHealthBarTextLeft, "SetText", function(self, ...)
				local fontFamily, fontSize, fontFlags = self:GetFont()
				self:SetFont(fontFamily, 10, fontFlags)
			end)
			TargetFrameHealthBarTextLeft:SetText(TargetFrameHealthBarTextLeft:GetText())
			
			hooksecurefunc(TargetFrameHealthBarTextRight, "SetText", function(self, ...)
				local fontFamily, fontSize, fontFlags = self:GetFont()
				self:SetFont(fontFamily, 10, fontFlags)
			end)
			TargetFrameHealthBarTextRight:SetText(TargetFrameHealthBarTextRight:GetText())

			hooksecurefunc(TargetFrameHealthBarText, "SetText", function(self, ...)
				local fontFamily, fontSize, fontFlags = self:GetFont()
				self:SetFont(fontFamily, 10, fontFlags)
			end)
			TargetFrameHealthBarText:SetText(TargetFrameHealthBarText:GetText())

			hooksecurefunc(TargetFrameManaBarTextLeft, "SetText", function(self, ...)
				local fontFamily, fontSize, fontFlags = self:GetFont()
				self:SetFont(fontFamily, 10, fontFlags)
			end)
			TargetFrameManaBarTextLeft:SetText(TargetFrameManaBarTextLeft:GetText())
			
			hooksecurefunc(TargetFrameManaBarTextRight, "SetText", function(self, ...)
				local fontFamily, fontSize, fontFlags = self:GetFont()
				self:SetFont(fontFamily, 10, fontFlags)
			end)
			TargetFrameManaBarTextRight:SetText(TargetFrameManaBarTextRight:GetText())

			hooksecurefunc(TargetFrameManaBarText, "SetText", function(self, ...)
				local fontFamily, fontSize, fontFlags = self:GetFont()
				self:SetFont(fontFamily, 10, fontFlags)
			end)
			TargetFrameManaBarText:SetText(TargetFrameManaBarText:GetText())
		end
	end
end

function DUFUpdateTargetTexture()
	local texture = "Interface\\Addons\\D4KiR DUnitFrames\\media\\UI-TargetingFrame"
	local class = UnitClassification("TARGET")
	if class == "worldboss" or class == "elite" then
		texture = "Interface\\Addons\\D4KiR DUnitFrames\\media\\UI-TargetingFrame-Elite"
	elseif class == "rareelite" then
		texture = "Interface\\Addons\\D4KiR DUnitFrames\\media\\UI-TargetingFrame-Rare-Elite"
	elseif class == "rare" then
		texture = "Interface\\Addons\\D4KiR DUnitFrames\\media\\UI-TargetingFrame-Rare"
	end
	TargetFrameTextureFrameTexture:SetTexture(texture);

	local height = DUFGetConfig("hpheight", 27)
	if TargetFrameTextureFrameTexture.spacer == nil then
		TargetFrameTextureFrameTexture.spacer = TargetFrameTextureFrame:CreateTexture(nil, "ARTWORK")
		TargetFrameTextureFrameTexture.spacer:SetDrawLayer("ARTWORK", 7)
		hooksecurefunc(TargetFrameTextureFrameTexture.spacer, "SetVertexColor", function(self, r, g, b, a)
			if self.setvertexcolor then return end
			self.setvertexcolor = true
			self:SetVertexColor(r, g, b, a)
			self.setvertexcolor = false
		end)
		TargetFrameTextureFrameTexture.spacer:SetVertexColor(1, 1, 1, 1)
	end
	TargetFrameTextureFrameTexture.spacer:SetSize(128, 16)
	TargetFrameTextureFrameTexture.spacer:SetPoint("LEFT", TargetFrameTextureFrameTexture, "LEFT", 4, 22 - height)
	TargetFrameTextureFrameTexture.spacer:SetTexture("Interface\\Addons\\D4KiR DUnitFrames\\media\\UI-TargetingFrame" .. "_Spacer")

	TargetFrameTextureFrameTexture:SetVertexColor(0, 0, 0, 1)

	if TargetFrameHealthBarTextLeft ~= nil then
		TargetFrameHealthBarTextLeft:SetPoint("LEFT", TargetFrameHealthBar, "LEFT", 0, 0.5)
		TargetFrameHealthBarTextRight:SetPoint("RIGHT", TargetFrameHealthBar, "RIGHT", -2, 0.5)
		TargetFrameHealthBarText:SetPoint("CENTER", TargetFrameHealthBar, "CENTER", 0, 0)

		TargetFrameManaBarTextLeft:SetPoint("LEFT", TargetFrameManaBar, "LEFT", 0, 1)
		TargetFrameManaBarTextRight:SetPoint("RIGHT", TargetFrameManaBar, "RIGHT", -2, 1)
		TargetFrameManaBarText:SetPoint("CENTER", TargetFrameManaBar, "CENTER", 0, 0)
	elseif TargetFrameTextureFrameHealthBarTextLeft ~= nil then
		TargetFrameTextureFrameHealthBarTextLeft:SetPoint("LEFT", TargetFrameHealthBar, "LEFT", 0, 0.5)
		TargetFrameTextureFrameHealthBarTextRight:SetPoint("RIGHT", TargetFrameHealthBar, "RIGHT", -2, 0.5)
		TargetFrameTextureFrameHealthBarText:SetPoint("CENTER", TargetFrameHealthBar, "CENTER", 0, 0)

		TargetFrameTextureFrameManaBarTextLeft:SetPoint("LEFT", TargetFrameManaBar, "LEFT", 0, 1)
		TargetFrameTextureFrameManaBarTextRight:SetPoint("RIGHT", TargetFrameManaBar, "RIGHT", -2, 1)
		TargetFrameTextureFrameManaBarText:SetPoint("CENTER", TargetFrameManaBar, "CENTER", 0, 0)
	end
end

hooksecurefunc(TargetFrameTextureFrameName, "SetText", function(self, text, ...)
	local fontFamily, fontSize, fontFlags = self:GetFont()
	self:SetFont(fontFamily, 8, fontFlags)
	self:ClearAllPoints()
	self:SetPoint("BOTTOM", TargetFrameHealthBar, "TOP", 0, 4)
end)
TargetFrameTextureFrameName:SetText(TargetFrameTextureFrameName:GetText())

hooksecurefunc(TargetFrameTextureFrameTexture, "SetVertexColor", function(self, ...)
	if self.setvertexcolor then return end
	self.setvertexcolor = true
	local r, g, b = GetBorderColor("TARGET")
	self:SetVertexColor(r, g, b, 1)
	if self.spacer then
		self.spacer:SetVertexColor(r, g, b, 1)
	end
	self.setvertexcolor = false
end)
TargetFrameTextureFrameTexture:SetVertexColor(1, 1, 1, 1)


-- Text
hooksecurefunc("TextStatusBar_UpdateTextStringWithValues", DUFUpdateText);

-- PlayerFrame
hooksecurefunc("PlayerFrame_ToPlayerArt", DUFUpdatePlayerFrame);

-- TargetFrame
hooksecurefunc("TargetFrame_Update", DUFUpdateTargetFrame);
hooksecurefunc("TargetFrame_CheckDead", DUFUpdateTargetFrame);
hooksecurefunc("TargetofTarget_Update", DUFUpdateTargetFrame);
hooksecurefunc("TargetFrame_CheckClassification", DUFUpdateTargetTexture);



--[[
hooksecurefunc("PlayerFrame_ToVehicleArt", nil);
hooksecurefunc("TargetFrame_CheckFaction", nil);
]]