-- By D4KiR

DUFBUILD = "CLASSIC"
if select(4, GetBuildInfo()) > 19999 then
	DUFBUILD = "RETAIL"
end



local vars = false
local addo = false

local DUFLoaded = false

DUFTAB = DUFTAB or {}
DUFTABPC = DUFTABPC or {}

function DUFGetConfig(key, value, pc)
	if DUFLoaded then
		if DUFTAB ~= nil and DUFTABPC ~= nil then
			if pc then
				if DUFTABPC[key] ~= nil then
					value = DUFTABPC[key]
				else
					DUFTABPC[key] = value
				end
			else
				if DUFTAB[key] ~= nil then
					value = DUFTAB[key]
				else
					DUFTAB[key] = value
				end
			end
		end
	end
	return value
end



function CreateSlider(parent, key, vval, x, y, vmin, vmax, steps, lstr, func)
	local SL = CreateFrame("Slider", nil, parent, "OptionsSliderTemplate")

	SL:SetWidth(600)
	SL:SetPoint("TOPLEFT", x, y)

	SL.Low:SetText(vmin)
	SL.High:SetText(vmax)
	
	SL.Text:SetText(DUFGT(lstr) .. ": " .. DUFGetConfig(key, vval))

	SL:SetMinMaxValues(vmin, vmax)

	SL:SetValue(DUFGetConfig(key, vval))

	SL:SetObeyStepOnDrag(steps)
	SL:SetValueStep(steps)

	SL:SetScript("OnValueChanged", function(self, val)
		val = string.format("%.0f", val)
		DUFTAB[key] = tonumber(val)
		SL.Text:SetText(DUFGT(lstr) .. ": " .. val)
		if func ~= nil then
			func()
		end
	end)

	return SL
end

function CreateCheckBox(parent, key, vval, x, y, lstr, pc)
	local CB = CreateFrame("CheckButton", nil, parent, "ChatConfigCheckButtonTemplate")
	CB:SetSize(16, 16)

	CB:SetPoint("TOPLEFT", x, y)

	CB.Text:SetPoint("LEFT", CB, "RIGHT", 0, 0)
	CB.Text:SetText(DUFGT(lstr))

	CB:SetChecked(DUFGetConfig(key, vval))

	CB:SetScript("OnClick", function(self, val)
		val = CB:GetChecked()
		if pc then
			DUFTABPC[key] = val
		else
			DUFTAB[key] = val
		end
		CB.Text:SetText(DUFGT(lstr))
	end)

	return CB
end

function CreateComboBox(parent, key, vval, x, y, lstr, tab, func)
	local CB = CreateFrame("Frame", nil, parent, "UIDropDownMenuTemplate")
	CB:SetPoint("TOPLEFT", x, y)

	
	CB.text = CB:CreateFontString(nil, "ARTWORK") 
	CB.text:SetFont("Fonts\\ARIALN.ttf", 12, "")
	CB.text:SetText(DUFGT(lstr))
	CB.text:SetPoint("LEFT", CB, "RIGHT", 0, 3)
	CB.Text:SetText(DUFGT(lstr) .. ": " .. tostring(DUFGetConfig(key, vval)))

	UIDropDownMenu_SetWidth(CB, 120)
	UIDropDownMenu_SetText(CB, DUFGetConfig(key, vval))

	-- Create and bind the initialization function to the dropdown menu
	UIDropDownMenu_Initialize(CB, function(self, level, menuList)
		for i, v in pairs(tab) do
			local info = UIDropDownMenu_CreateInfo()
			info.func = self.SetValue
			info.text = v
			info.arg1 = v
			UIDropDownMenu_AddButton(info)
		end
	end)

	function CB:SetValue(newValue)
		DUFTAB[key] = newValue

		UIDropDownMenu_SetText(CB, newValue)
		CloseDropDownMenus()

		if func ~= nil then
			func()
		end
	end

	return CB
end



local Y = 0
local H = 16
local BR = 30

local SORTTAB = {}
SORTTAB = {"Group", "Role"}

function DUFInitSettings()
	local DUFSettings = {}

	local DUFname = "DUnitFrames"
	local DUFcolorname = "|c008888ff"
	local DUFauthor = "D4KiR"
	local DUFcolorauthor = "|c0000ffff"

	local settingname = DUFcolorauthor .. DUFauthor .. " " .. DUFcolorname .. DUFname
	DUFSettings.panel = CreateFrame("FRAME")
	DUFSettings.panel.name = settingname

	Y = 0
	H = 16
	BR = 30

	Y = Y - 10
	local text = DUFSettings.panel:CreateFontString(nil, "ARTWORK")
	text:SetFont(STANDARD_TEXT_FONT, 10, "OUTLINE")
	text:SetPoint("TOPLEFT", DUFSettings.panel, "TOPLEFT", 10, Y)
	text:SetText("Settings")

	CreateComboBox(DUFSettings.panel, "portraimode", "New", 0, -30, "portraimode", {"New", "Old", "Default"}, function()
		PlayerFrameTexture:SetVertexColor(0, 0, 0, 1)
	end)

	CreateComboBox(DUFSettings.panel, "bordermode", "Class+Status", 0, -60, "bordermode", {"Class+Status", "Class", "Status", "Dark", "Black", "Default"}, function()
		PlayerFrameTexture:SetVertexColor(1, 1, 1, 1)
		TargetFrameTextureFrameTexture:SetVertexColor(1, 1, 1, 1)
	end)

	CreateSlider(DUFSettings.panel, "hpheight", 27, 10, -90, 12, 27, 1, "hpheight", function()
		DUFUpdatePlayerFrame()
		DUFUpdateTargetFrame()
		DUFUpdateTargetTexture()
	end)

	local b = CreateFrame("Button", "MyButton", DUFSettings.panel, "UIPanelButtonTemplate")
	b:SetSize(200, 24) -- width, height
	b:SetText("DISCORD")
	b:SetPoint("BOTTOMLEFT", 10, 10)
	b:SetScript("OnClick", function()
		local iconbtn = 32
		local s = CreateFrame("Frame", nil, UIParent) -- or you actual parent instead
		s:SetSize(300, 2 * iconbtn + 2 * 10)
		s:SetPoint("CENTER")

		s.texture = s:CreateTexture(nil, "BACKGROUND")
		s.texture:SetColorTexture(0, 0, 0, 0.5)
		s.texture:SetAllPoints(s)

		s.text = s:CreateFontString(nil,"ARTWORK") 
		s.text:SetFont("Fonts\\ARIALN.ttf", 11, "")
		s.text:SetText("Feedback")
		s.text:SetPoint("CENTER", s, "TOP", 0, -10)

		local eb = CreateFrame("EditBox", "logEditBox", s, "InputBoxTemplate")
		eb:SetFrameStrata("DIALOG")
		eb:SetSize(280, iconbtn)
		eb:SetAutoFocus(false)
		eb:SetText("https://discord.gg/UeBsafs")
		eb:SetPoint("TOPLEFT", 10, -10 - iconbtn)

		s.close = CreateFrame("Button", "closediscord", s, "UIPanelButtonTemplate")
		s.close:SetFrameStrata("DIALOG")
		s.close:SetPoint("TOPLEFT", 300 - 10 - iconbtn, -10)
		s.close:SetSize(iconbtn, iconbtn)
		s.close:SetText("X")
		s.close:SetScript("OnClick", function(self, btn, down)
			s:Hide()
		end)
	end)

	InterfaceOptions_AddCategory(DUFSettings.panel)
end


SetCVar("ScriptErrors", 1)
local f = CreateFrame("Frame")
f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("VARIABLES_LOADED")
f:RegisterEvent("PLAYER_ENTERING_WORLD")
function f:OnEvent(event)
	if event == "VARIABLES_LOADED" then
		vars = true
	end
	if event == "ADDON_LOADED" then
		addo = true
	end
	if vars and addo and not DUFLoaded then
		DUFLoaded = true
		
		UnitFramePortrait_Update(PlayerPortrait)
		PlayerFrameTexture:SetVertexColor(1, 1, 1, 1)

		C_Timer.After(0, function()
			DUFInitSettings()
		end)
	end
end
f:SetScript("OnEvent", f.OnEvent)
